de.caff.generics.function

## Interface IntOperator1

- All Superinterfaces:
    java.util.function.IntUnaryOperator
  Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface IntOperator1
      extends java.util.function.IntUnaryOperator

  Unary operator with a int argument and result.
  Since:
    October 31, 2019
  Author:
    Rammi

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static IntOperator1` | `BIT_FLIP` Integer operator BIT FLIP (`~`).
    `static IntOperator1` | `NEGATE` Integer operator NEGATE.

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default IntOperator1` | `andThen(IntOperator1 after)` Create a function which applies this function and feeds the result into the next function.
    `static IntOperator1` | `from(java.util.function.IntUnaryOperator operator)` Make a standard unary int operator usable as `IntOperator1`.
    `default IntOperator0` | `partial(int argument)` Create a zero argument function from this one by applying a constant argument.

    - ### Methods inherited from interface java.util.function.IntUnaryOperator

      `andThen, applyAsInt, compose, identity`

- - ### Field Detail

    - #### NEGATE

          static final IntOperator1 NEGATE

      Integer operator NEGATE. Beware: as with usual NEGATE not only `0` also `Integer.MIN_VALUE` is its own negative.

    - #### BIT_FLIP

          static final IntOperator1 BIT_FLIP

      Integer operator BIT FLIP (`~`).

  - ### Method Detail

    - #### partial

          @NotNull
          default IntOperator0 partial(int argument)

      Create a zero argument function from this one by applying a constant argument. Although useless for pure functions it can be useful in cases where the zero argument function is a factory (and therefore not pure).
      Parameters:
        `argument` - constant argument
      Returns:
        zero argument function

    - #### andThen

          @NotNull
          default IntOperator1 andThen(@NotNull
                                                IntOperator1 after)

      Create a function which applies this function and feeds the result into the next function.
      Parameters:
        `after` - function called with the result of this function
      Returns:
        chained function

    - #### from

          @NotNull
          static IntOperator1 from(@NotNull
                                            java.util.function.IntUnaryOperator operator)

      Make a standard unary int operator usable as `IntOperator1`. This is useful if you want to make use of the extended functionality of this implementation.
      Parameters:
        `operator` - operator to be used as a `IntOperator1`
      Returns:
        `IntOperator1` view of the incoming operator, or possibly just a cast if `operator` already has the correct type